using System;
using System.ServiceProcess;
using System.Configuration.Install;
using System.ComponentModel;
using System.Diagnostics;
using System.Net.Mail;
using System.Net;


using System.Windows.Forms;
public class Eventer : ServiceBase
{
    EventLog SysLog;
    String SMTP;
    String email;
    String user;
    String password;
    public Eventer()
    {
        this.ServiceName = "Eventer";
        this.CanStop = true;
        this.CanPauseAndContinue = false;
        this.AutoLog = true;
    }

    protected override void OnStart(string[] args)
    {


        if (args.Length == 4)
        {
            SMTP = args[0];
            email = args[1];
            user = args[2];
            password = args[3];
        }




        SysLog = new EventLog("System");
        SysLog.EntryWritten += new EntryWrittenEventHandler(MyOnEntryWritten);
        this.EventLog.EntryWritten += new EntryWrittenEventHandler(MyOnEntryWritten);
        this.EventLog.EnableRaisingEvents = true;
        SysLog.EnableRaisingEvents = true;
    }

    protected override void OnStop()
    {
        this.EventLog.EnableRaisingEvents = false;
        this.EventLog.EntryWritten -= new EntryWrittenEventHandler(MyOnEntryWritten);
        SysLog.EnableRaisingEvents = false;
        SysLog.EntryWritten -= new EntryWrittenEventHandler(MyOnEntryWritten);
    }

    public static void Main()
    {

        ServiceBase.Run(new Eventer());
    }

    public void MyOnEntryWritten(Object source, EntryWrittenEventArgs e)
    {


        MailMessage mail = new MailMessage("Eventer@Pc", email);
        mail.Subject = "Event Notification";

        mail.Body = e.Entry.Source
            + Environment.NewLine + e.Entry.Message
            + Environment.NewLine + e.Entry.TimeGenerated.ToLongDateString()
            + " " + e.Entry.TimeGenerated.ToLongTimeString()
            + Environment.NewLine + e.Entry.MachineName
            + Environment.NewLine + e.Entry.EntryType;


        SmtpClient mailbox = new SmtpClient(SMTP);
        mailbox.Credentials = new NetworkCredential(user, password);
        mailbox.Send(mail);

    }


}
[RunInstaller(true)]
public class EventerInstaller : Installer
{
    private ServiceProcessInstaller processInstaller;
    private ServiceInstaller serviceInstaller;

    public EventerInstaller()
    {
        processInstaller = new ServiceProcessInstaller();
        serviceInstaller = new ServiceInstaller();

        processInstaller.Account = ServiceAccount.LocalSystem;
        serviceInstaller.StartType = ServiceStartMode.Automatic;

        serviceInstaller.ServiceName = "Eventer";
        serviceInstaller.
        Installers.Add(serviceInstaller);
        Installers.Add(processInstaller);
    }
}




